oVirt: Failed to set Build: undefined method `symbolize_keys' for nil:NilClass

01/23/2014 08:34 PM - Frank Wall

Status: Closed   

Priority: Normal   

Assignee:    

Category: Compute resources   

Target version: 1.4.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

RC[1,2] seems to have issues with some build actions if compute ressources are involved. The problem does not occur with "bare

metal" hosts.

Setting up a new host...

- "new host"

- Deploy on: oVirt

...works just fine. A VM is created and provisioning starts as usual. Only a few actions result in failure:

A) calling /unattended/built

B) click "Cancel Build"

The error message is basically the same:

A)

Failed to set Build on testhost001.install.example.com: undefined method `symbolize_keys' for nil:NilClass

Completed 409 Conflict in 192.7ms (ActiveRecord: 8.6ms)

B)

Failed to set Build on testhost001.install.example.com: undefined method `symbolize_keys' for nil:NilClass

Failed to save:

Redirected to https://fw.example.com/hosts/new

Completed 302 Found in 81.2ms (ActiveRecord: 8.7ms)

Attached you'll find a full debug log. Unfortunately there is no stacktrace available, although "debug" logging was enabled.

Related issues:

Related to Foreman - Bug #4375: Kickstart provisioning is on a loop when usin... Closed 02/18/2014

Associated revisions

Revision ec4ff916 - 01/28/2014 09:04 PM - Michael Moll 

fixes #4173 - don't update CR attrs when none available, taken from GH-1184

Revision 68d0814c - 01/29/2014 09:02 AM - Michael Moll 

fixes #4173 - don't update CR attrs when none available, taken from GH-1184

(cherry picked from commit ec4ff916ebefa8fc0d4ac41548d02407e7cf8fac)

History

#1 - 01/24/2014 08:38 AM - Dominic Cleal

- translation missing: en.field_release deleted (2)

If you don't mind changing your install slightly, you could try commenting out the "rescue/logger/false" lines in app/models/host/managed.rb in the built

method around line 204.  This might let an exception bubble up better.
https://fw.example.com/hosts/new


Alternatively, add into the rescue block:

logger.debug "Error: #{e.message}\n " + e.backtrace.join("\n ")

#2 - 01/24/2014 10:16 AM - Frank Wall

- File trace.txt added

Thanks Dominic, you'll find the stacktrace attached.

#3 - 01/24/2014 10:35 AM - Dominic Cleal

- Subject changed from Failed to set Build: undefined method `symbolize_keys' for nil:NilClass to oVirt: Failed to set Build: undefined method

`symbolize_keys' for nil:NilClass

Thanks, this is specific to oVirt as it's the only provider that supports updates to existing VMs.

I think in app/models/concerns/orchestration/compute.rb, compute_update_required? we should do something like:

compute_resource.update_required?(old.compute_attributes, (compute_attributes || {}).symbolize_keys)

#4 - 01/24/2014 02:47 PM - Frank Wall

I can confirm that this solves my problem.

#5 - 01/24/2014 02:52 PM - Dominic Cleal

- Status changed from New to Ready For Testing

- Assignee set to Dominic Cleal

- Target version set to 1.9.2

https://github.com/theforeman/foreman/pull/1193

Thanks for testing!

#6 - 01/28/2014 02:22 PM - Anonymous

https://github.com/theforeman/foreman/pull/1203

#7 - 01/28/2014 09:27 PM - Dominic Cleal

- translation missing: en.field_release set to 2

- Assignee changed from Dominic Cleal to Anonymous

#8 - 01/28/2014 09:31 PM - Anonymous

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset ec4ff916ebefa8fc0d4ac41548d02407e7cf8fac.

#9 - 02/18/2014 10:41 AM - Dominic Cleal

- Related to Bug #4375: Kickstart provisioning is on a loop when using compute profiles with ovirt Compute Resource. added

Files

production.log 7.92 KB 01/23/2014 Frank Wall

trace.txt 15.1 KB 01/24/2014 Frank Wall
